#include <linux/module.h>
#include <linux/timekeeping.h>

MODULE_LICENSE("Dual MIT/GPL");
MODULE_AUTHOR("Marcin Bis <marcin@bis-linux.com>");
MODULE_DESCRIPTION("This is module description shown by modinfo.");

static int howmany = 1;
/* This variable will be module parameter.
 * <variable name>, <type (not C>, </sys/module/parameters..file permissions> 
 * Usage: insmod mod.ko howmany=N */
module_param(howmany, int, 0644);
MODULE_PARM_DESC(howmany, "How many times to say \"hello\".");

static struct timeval start_time;

static void say_hello(void)
{
	int i;
	for (i = 1; i <= howmany; i++)
      		pr_info("[%d/%d] Hello!\n",i,howmany);
}



static int __init first_init(void)
{
	pr_info("Loading first!\n");

	do_gettimeofday(&start_time);

	say_hello();
	return 0;
}
module_init(first_init);

static void __exit first_exit(void)
{
	struct timeval end_time;
	do_gettimeofday(&end_time);

	pr_info("Unloading first ater %ld sec!\n", end_time.tv_sec - start_time.tv_sec);
	say_hello();
}
module_exit(first_exit);
