#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/fs.h>
/* Copy data to/from userspace */
#include <linux/uaccess.h>
#include <linux/io.h>

#include <linux/miscdevice.h>

MODULE_LICENSE("Dual MIT/GPL");
MODULE_AUTHOR("Marcin Bis <marcin@bis-linux.com>");
MODULE_DESCRIPTION("Example character device skeleton");

/* File operations */

/* User is reading data from file */
static ssize_t skel_read_file(struct file *file, char __user *userbuf,
                                   size_t count, loff_t *ppos)
{
	pr_info("skel_read_file()\n");
	return 0;
}

/* User is writing to file */
static ssize_t skel_write_file(struct file *file, const char __user *userbuf,
                                   size_t count, loff_t *ppos)
{
	pr_info("skel_write_file()\n");
	return count;
}

static struct file_operations skel_fops = {
		.owner = THIS_MODULE,
		.read = skel_read_file,
		.write = skel_write_file,
};

static struct miscdevice skel_miscdevice = {
		.minor = MISC_DYNAMIC_MINOR,
		.name = "skel",
		.fops = &skel_fops,
};

/* Module initialization */
int __init skel_init(void)
{
	pr_info("Skel module initalization.\n");
	return misc_register(&skel_miscdevice);
}
module_init(skel_init);

void __exit skel_exit(void)
{
	pr_info("Skel module deinitalization.\n");
	misc_deregister(&skel_miscdevice);
}
module_exit(skel_exit);
